<?xml version="1.0" encoding="utf-8"?>
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
    package="net.micode.notes"
    android:versionCode="1"
    android:versionName="0.1"> <!-- - 指定应用程序需要支持的最低的 Android SDK 版本 -->
    <uses-sdk android:minSdkVersion="14" />

    <!-- - 权限声明 -->
    <!-- - 写入 SD 卡的权限 -->
    <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" /> <!-- - 创建、删除有关快捷方式的权限 -->
    <uses-permission android:name="com.android.launcher.permission.INSTALL_SHORTCUT" /> <!-- - 访问网络的权限 -->
    <uses-permission android:name="android.permission.INTERNET" /> <!-- - 读取联系人的权限 -->
    <uses-permission android:name="android.permission.READ_CONTACTS" /> <!-- - 账户管理的权限 -->
    <uses-permission android:name="android.permission.MANAGE_ACCOUNTS" /> <!-- - 验证账户的权限 -->
    <uses-permission android:name="android.permission.AUTHENTICATE_ACCOUNTS" />
    <uses-permission android:name="android.permission.GET_ACCOUNTS" />
    <uses-permission android:name="android.permission.USE_CREDENTIALS" /> <!-- - 开机自动运行权限 -->
    <uses-permission android:name="android.permission.RECEIVE_BOOT_COMPLETED" />

    <application
        android:icon="@drawable/icon_app_1"
        android:label="@string/app_name">
        <activity
            android:name=".ui.SplashActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:exported="true"
            android:theme="@style/Theme.Notes.Fullscreen">
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />
                <category android:name="android.intent.category.LAUNCHER" />
            </intent-filter>
        </activity>

        <!-- - 应用程序的入口 NotesListActivity -->
        <activity
            android:name=".ui.NotesListActivity"
            android:configChanges="keyboardHidden|orientation|screenSize"
            android:exported="true"
            android:label="@string/app_name"
            android:launchMode="singleTop"
            android:theme="@style/NoteTheme"
            android:windowSoftInputMode="adjustPan">

        </activity>

        <!-- - 笔记编辑 Activity -->
        <activity
            android:name=".ui.NoteEditActivity"
            android:configChanges="keyboardHidden|orientation|screenSize"
            android:launchMode="singleTop"
            android:theme="@style/NoteTheme">

            <!-- - 笔记编辑 Activity 的 Intent Filter，用于接收其他应用程序发送过来的消息 -->
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />

                <category android:name="android.intent.category.DEFAULT" />
                <!-- - 笔记编辑 Activity 可以处理的 MIME 类型 -->
                <data
                    android:host="com.example.notes.provider"
                    android:mimeType="vnd.android.cursor.item/text_note"
                    android:path="/notes"
                    android:scheme="content" />
                <data
                    android:host="com.example.notes.provider"
                    android:mimeType="vnd.android.cursor.item/call_note"
                    android:path="/notes"
                    android:scheme="content" />
            </intent-filter>

            <!-- - 笔记编辑 Activity 的 Intent Filter，用于接收其他应用程序发送过来的消息 -->
            <intent-filter>
                <action android:name="android.intent.action.INSERT_OR_EDIT" />

                <category android:name="android.intent.category.DEFAULT" />
                <!-- - 笔记编辑 Activity 可以处理的 MIME 类型 -->
                <data android:mimeType="vnd.android.cursor.item/text_note" />
                <data android:mimeType="vnd.android.cursor.item/call_note" />
            </intent-filter>

            <!-- - 搜索 Intent Filter，用于响应搜索请求 -->
            <intent-filter>
                <action android:name="android.intent.action.SEARCH" />

                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>

            <!-- - 搜索框的配置信息 -->
            <meta-data
                android:name="android.app.searchable"
                android:resource="@xml/searchable" />
        </activity> <!-- - 笔记供应器，用于共享笔记数据 -->
        <provider
            android:name=".data.NotesProvider"
            android:authorities="micode_notes"
            android:multiprocess="true" /> <!-- - 笔记小部件，支持两种大小 -->
        <receiver
            android:name=".widget.NoteWidgetProvider_2x"
            android:label="@string/app_widget2x2">

            <!-- - 笔记小部件的 Intent Filter，用于接收系统广播和小部件更新操作 -->
            <intent-filter>
                <action android:name="android.appwidget.action.APPWIDGET_UPDATE" />
                <action android:name="android.appwidget.action.APPWIDGET_DELETED" />
                <action android:name="android.intent.action.PRIVACY_MODE_CHANGED" />
            </intent-filter>

            <!-- - 笔记小部件的配置信息 -->
            <meta-data
                android:name="android.appwidget.provider"
                android:resource="@xml/widget_2x_info" />
        </receiver>
        <receiver
            android:name=".widget.NoteWidgetProvider_4x"
            android:label="@string/app_widget4x4">

            <!-- - 笔记小部件的 Intent Filter，用于接收系统广播和小部件更新操作 -->
            <intent-filter>
                <action android:name="android.appwidget.action.APPWIDGET_UPDATE" />
                <action android:name="android.appwidget.action.APPWIDGET_DELETED" />
                <action android:name="android.intent.action.PRIVACY_MODE_CHANGED" />
            </intent-filter>

            <!-- - 笔记小部件的配置信息 -->
            <meta-data
                android:name="android.appwidget.provider"
                android:resource="@xml/widget_4x_info" />
        </receiver> <!-- - 启动时需要初始化闹钟服务 -->
        <receiver android:name=".ui.AlarmInitReceiver">
            <intent-filter>
                <action android:name="android.intent.action.BOOT_COMPLETED" />
            </intent-filter>
        </receiver> <!-- - 闹钟服务 -->
        <receiver
            android:name=".ui.AlarmReceiver"
            android:process=":remote"></receiver> <!-- - 闹钟提示 Activity -->
        <activity
            android:name=".ui.AlarmAlertActivity"
            android:label="@string/app_name"
            android:launchMode="singleInstance"
            android:theme="@android:style/Theme.Holo.Wallpaper.NoTitleBar"></activity> <!-- - 首选项 Activity -->
        <activity
            android:name=".ui.NotesPreferenceActivity"
            android:label="@string/preferences_title"
            android:launchMode="singleTop"
            android:theme="@android:style/Theme.Holo.Light"></activity> <!-- - GTask 同步服务 -->
        <service
            android:name=".gtask.remote.GTaskSyncService"
            android:exported="false"></service> <!-- - 默认搜索 Activity -->
        <meta-data
            android:name="android.app.default_searchable"
            android:value=".ui.NoteEditActivity" />
    </application>

</manifest>